; http://radohlam.ru -  ,   
;---------------------------------------------------------
 .device ATtiny13
 .include "tn13def.inc"
 .list
;---   
 .def  w=r16     ;    
 .def  T_Cr=r17  ;  
 .def  T_NC=r18  ;  -   
 .def  T_0=r19   ;    
 .def  LBC=r20   ;   
 .def  MBC=r21   ;   
 .def  Sleep_Counter=r22
;--  
 .equ  Cr1=22    ;  1 
 .equ  Cr0=64    ;  0 
 .equ  NCr=32    ; -     
 .equ  Sys=29    ;  
 .equ  CMD_1=1   ;   1
 .equ  CMD_2=2   ;   2
 .equ  CMD_3=3   ;   3
 .equ  CMD_4=4   ;   4
;---------------------------------------------------------

 .cseg
 .org 0
      rjmp  Init       ; reset
      reti             ; INT0
      reti             ; Pin Change
      reti             ; Timer (  .  )
      reti             ; EEPROM
      reti             ; comparator
      reti             ; timer compare match A
      reti             ; timer compare match B
      reti             ; watchdog
      reti             ; ADC
;---   ------------------------------------
Init: ldi  w,RAMEND     ;   
      out  SPL,w        ;     RAM
      sbi  ACSR,7       ;  
      ldi  w,0b00001000 ;     
      out  DDRB,w
      ldi  w,0b11110111 ;   
      out  PORTB,w      ;     
;--    
      ldi  MBC,Sys        ;      
      sbr  MBC,0b11000000 ;  -
;--    
      ldi w, 0b00010111
      out PCMSK,w
      ldi w,0b00100000
      out GIMSK,w
;-----------------------
Scan:
	  sei
      ldi Sleep_Counter, 5 ;    5  (       - )
Test_Sleep:
          dec Sleep_Counter
          brne Test_Buttons  ;     5  -   
          ldi w,0b00110000
          out MCUCR,w        ;     Power Down
          sleep              ; 
          clr w
          out MCUCR,w        ;  
          ldi Sleep_Counter, 5  ;    5 
Test_Buttons:
      sbis PINB,4         ;    PB4   -  1
      rjmp Tx_CMD1
      sbis PINB,2         ;    PB2   -  2
      rjmp Tx_CMD2
      sbis PINB,0         ;    PB0   -  3
      rjmp Tx_CMD3
      sbis PINB,1         ;    PB1   -  4
      rjmp Tx_CMD4
      sbr  MBC,0b00100000 ;  toggle bit  1 ( )
      rjmp Test_Sleep
;---     ------------------
Tx_CMD1:
      ldi  LBC,CMD_1     ;       1
      rjmp TxRC
Tx_CMD2:
      ldi  LBC,CMD_2     ;       2
      rjmp TxRC
Tx_CMD3:
      ldi  LBC,CMD_3     ;       3
      rjmp TxRC
Tx_CMD4:
      ldi  LBC,CMD_4     ;       4
      rjmp TxRC
;---   RC-5---------------------------------
TxRC: cli
      sbrc  MBC,7      ; Startbit 1.    1 - 
      rcall Tx_1       ; Tx_1,    0 -  Tx_0
      sbrs  MBC,7
      rcall Tx_0
;------------
      sbrc  MBC,6      ; Startbit 2
      rcall Tx_1
      sbrs  MBC,6
      rcall Tx_0
;------------
      sbrc  MBC,5      ; Toggle bit
      rcall Tx_1
      sbrs  MBC,5
      rcall Tx_0
;------------
      sbrc  MBC,4      ; System bit 4
      rcall Tx_1
      sbrs  MBC,4
      rcall Tx_0
;------------
      sbrc  MBC,3      ; System bit 3
      rcall Tx_1
      sbrs  MBC,3
      rcall Tx_0
;------------
      sbrc  MBC,2      ; System bit 2
      rcall Tx_1
      sbrs  MBC,2
      rcall Tx_0
;------------
      sbrc  MBC,1      ; System bit 1
      rcall Tx_1
      sbrs  MBC,1
      rcall Tx_0
;------------
      sbrc  MBC,0      ; System bit 0
      rcall Tx_1
      sbrs  MBC,0
      rcall Tx_0
;------------
      sbrc  LBC,5      ; Command bit 5
      rcall Tx_1
      sbrs  LBC,5
      rcall Tx_0
;------------
      sbrc  LBC,4      ; Command bit 4
      rcall Tx_1
      sbrs  LBC,4
      rcall Tx_0
;------------
      sbrc  LBC,3      ; Command bit 3
      rcall Tx_1
      sbrs  LBC,3
      rcall Tx_0
;------------
      sbrc  LBC,2      ; Command bit 2
      rcall Tx_1
      sbrs  LBC,2
      rcall Tx_0
;------------
      sbrc  LBC,1      ; Command bit 1
      rcall Tx_1
      sbrs  LBC,1
      rcall Tx_0
;------------
      sbrc  LBC,0      ; Command bit 0
      rcall Tx_1
      sbrs  LBC,0
      rcall Tx_0
;------------
      cbr   MBC,0b00100000 ;  toggle bit ( )
;---------------------------------------------------------
;--- ,    (50 ), ..  
;--- 100   (RCN) -------------------------
      ldi   T_0,99
pause:
      rcall RCN
      dec   T_0
      brne  pause
      rjmp  Scan
;---    ----------------------------
;---      ----------------
;---     -------------------
Tx_0: rcall RCY   ;   
      rcall RCN   ;   
      ret
;---     ----------------
Tx_1: rcall RCN   ;   
      rcall RCY   ;   
      ret
;---------------------------------------------------------
;---    "ON"  "OFF" ----
;---    ("ON") -----------------
RCY:  ldi   T_NC,NCr   ;  - 
Y_001:
      ldi   T_Cr,Cr1   ;   
      sbi   PORTB,3    ;  1  
Cr1_Y:
      dec   T_Cr
      brne  Cr1_Y      ;     
      cbi   PORTB,3    ;  0  
      ldi   T_Cr,Cr0   ;    
Cr0_Y:
      dec   T_Cr
      brne  Cr0_Y      ;     
      dec   T_NC
      brne  Y_001
      ret
;---    ("OFF") ------------------
RCN:  ldi   T_NC,NCr   ;     
N_001:
      ldi   T_Cr,Cr1   ;  ,    
      nop              ;     , 
Cr1_N:
      dec   T_Cr       ;     
      brne  Cr1_N      ;   -  sbi, cbi
      nop              ;   nop
      ldi   T_Cr,Cr0

Cr0_N:
      dec   T_Cr
      brne  Cr0_N
      dec   T_NC
      brne  N_001
      ret
;---------------------------------------------------------
